﻿# -*- coding: utf-8 -*-

import bpy

#### =======================================================================
class OBJECT_OT_MakeBlankShape(bpy.types.Operator):
	'''空シェイプを作成'''
	bl_idname = "object.make_blank_shape"
	bl_label  = "空シェイプを作成"
	bl_options= {"REGISTER", "UNDO"}

	name: bpy.props.StringProperty(name="Name", description="名", default="Mesh")
	type: bpy.props.EnumProperty(name="Type", default="MESH",
		items=(
			("MESH", "Mesh", "", "OUTLINER_DATA_MESH", 0),
			("CURVE", "Curve", "", "OUTLINER_DATA_CURVE", 1),
		))

	#### --------------------------------
	def execute(self, context):
#		bpy.ops.object.add(type= self.type)
#		ob = context.selected_objects[0]	# 元選択は破棄され, 作成結果が選択に入る.
#		ob.name = self.name

		if(self.type == "CURVE"):
			sh = bpy.data.curves.new(self.name, type="CURVE")
		else:
			sh = bpy.data.meshes.new(self.name)

		ob = bpy.data.objects.new(self.name, sh)
		context.view_layer.active_layer_collection.collection.objects.link(ob)
		bpy.ops.object.select_all(action="DESELECT")
		ob.select_set(True)
		context.view_layer.objects.active = ob

		self.report({"OPERATOR"}, ob.name)
		return({"FINISHED"})

#### =======================================================================
def AddMenu(self, context):
	'''types.VIEW3D_MT_mesh_add 追加用'''
	self.layout.separator()
	op = self.layout.operator(OBJECT_OT_MakeBlankShape.bl_idname, text= "ブランク", icon="EMPTY_AXIS")
	op.type = "MESH"
